/**
 * PETALS - PETALS Services Platform. Copyright (c) 2007 EBM Websourcing,
 * http://www.ebmwebsourcing.com/
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version. This library is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * 
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */
package org.ow2.petals.bpel.engine.bootstrap;

import java.util.ArrayList;
import java.util.List;

import org.ow2.petals.component.framework.DefaultBootstrap;
import org.ow2.petals.component.framework.jbidescriptor.generated.Jbi;
import org.w3c.dom.Element;

/**
 * 
 * @author mcarrolle
 * 
 */
public class BPELBootstrap extends DefaultBootstrap {

    @Override
    protected List<String> getAttributeList() {
        final List<String> attributes = new ArrayList<String>();
        attributes.add("internalLogger");
        attributes.add("explorer");
        return attributes;
    }

    /**
     * Set the internal logger host.
     * 
     * @param host
     */
    public void setInternalLogger(final boolean logger) {
        this.setParam("internal-logger", String.valueOf(logger));
    }

    /**
     * Get the internal logger value
     */
    public boolean getInternalLogger() {
        return Boolean.valueOf(this.getParam("internal-logger"));
    }

    /**
     * Set explorer
     * 
     * @param explorer
     */
    public void setExplorer(final boolean explorer) {
        this.setParam("explorer", String.valueOf(explorer));
    }

    /**
     * Get explorer
     * 
     * @return
     */
    public boolean getExplorer() {
        return Boolean.valueOf(this.getParam("explorer"));
    }

    /**
     * Set mail parameter
     * 
     * @param key
     * @param value
     * @param jbi
     */
    private void setParam(String key, String value) {
        Jbi jbi = this.getJbiComponentConfiguration();
        for (Element element : jbi.getComponent().getAny()) {
            if (element.getLocalName().equals(key)) {
                element.setTextContent(value);
            }
        }
    }

    /**
     * Get a parameter.
     * 
     * @param key
     * @param value
     * @param jbi
     */
    private String getParam(String key) {
        Jbi jbi = this.getJbiComponentConfiguration();
        for (Element element : jbi.getComponent().getAny()) {
            if (element.getLocalName().equals(key)) {
                return element.getTextContent();
            }
        }
        return null;
    }
}
